diff --git a/CHANGELOG b/CHANGELOG
index 77178a0..9deaae2 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -6,6 +6,7 @@
 - check for fstab update and retry if not updated.
 - change file map lexer to allow white-space only blank lines.
 - remove macro substitution in automount.8 man page (Guillaume Rousse).
+- correct hesiod library check in configure (Guillaume Rousse).
 
 20/2/2007 autofs-5.0.1
 ----------------------
diff --git a/aclocal.m4 b/aclocal.m4
index 4816cfe..5202605 100644
--- a/aclocal.m4
+++ b/aclocal.m4
@@ -178,7 +178,11 @@ dnl Check for lib hesiod
 dnl --------------------------------------------------------------------------
 AC_DEFUN([AF_CHECK_LIBHESIOD],
 [AC_MSG_CHECKING(for libhesiod)
-LIBS="$LIBHESIOD -lhesiod -lresolv"
+
+# save current ldflags
+af_check_hesiod_save_ldflags="$LDFLAGS"
+LDFLAGS="$LDFLAGS -lhesiod -lresolv"
+
 AC_TRY_LINK(
   [ #include <hesiod.h> ],
   [ char *c; hesiod_init(&c); ],
@@ -186,5 +190,8 @@ AC_TRY_LINK(
     LIBHESIOD="$LIBHESIOD -lhesiod -lresolv"
     AC_MSG_RESULT(yes) ],
   [ AC_MSG_RESULT(no) ])
+
+# restore ldflags
+LDFLAGS="$af_check_hesiod_save_ldflags"
 ])
 
